Index: /trunk/src/org/expeditee/gui/FrameGraphics.java
===================================================================
--- /trunk/src/org/expeditee/gui/FrameGraphics.java	(revision 1101)
+++ /trunk/src/org/expeditee/gui/FrameGraphics.java	(revision 1102)
@@ -19,18 +19,4 @@
 package org.expeditee.gui;
 
-import java.awt.Color;
-import java.awt.Dimension;
-import java.awt.EventQueue;
-import java.awt.Graphics;
-import java.awt.Graphics2D;
-import java.awt.GraphicsDevice;
-import java.awt.GraphicsEnvironment;
-import java.awt.Image;
-import java.awt.Polygon;
-import java.awt.Rectangle;
-import java.awt.RenderingHints;
-import java.awt.geom.Area;
-import java.lang.reflect.Method;
-import java.awt.image.BufferedImage;
 import java.util.Collection;
 import java.util.Collections;
@@ -41,13 +27,20 @@
 import java.util.ListIterator;
 
+import org.expeditee.core.Clip;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Image;
+import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.input.StandardInputEventListeners;
+import org.expeditee.gio.input.KBMInputEvent.Key;
 import org.expeditee.items.Circle;
 import org.expeditee.items.Dot;
 import org.expeditee.items.Item;
-import org.expeditee.items.ItemUtils;
 import org.expeditee.items.Line;
 import org.expeditee.items.UserAppliedPermission;
 import org.expeditee.items.XRayable;
 import org.expeditee.items.Item.HighlightMode;
-import org.expeditee.items.widgets.InteractiveWidget;
+import org.expeditee.items.widgets.Widget;
 import org.expeditee.items.widgets.WidgetEdge;
 import org.expeditee.settings.UserSettings;
@@ -55,305 +48,55 @@
 public class FrameGraphics {
 
-	// the graphics used to paint with
-	private static Graphics2D _DisplayGraphics;
-
-	// the maximum size that can be used to paint on
-	private static Dimension _MaxSize = null;
-
 	// Final passes to rendering the current frame
 	private static LinkedList<FrameRenderPass> _frameRenderPasses = new LinkedList<FrameRenderPass>();
-
-	// modes
-	protected static final int MODE_NORMAL = 0;
-
-	protected static final int MODE_AUDIENCE = 1;
-
-	protected static final int MODE_XRAY = 2;
 	
-	protected static final int MODE_AUDIENCE_FULLSCREEN = 4;
-	
-
-	// The following used to be true in the past:
-	//   Start in XRay mode so that errors aren't thrown when parsing the profile
-	//   frame if it has images on it
-	// More recently, so Exploratory Search starts up correctly with images
-	// rendered (rather than their @i form) the following assignment was changed
-	// to MODE_NORMAL.  No issue of parse errors has not been seen
-	private static int _Mode = MODE_NORMAL;
-
-	private FrameGraphics() {
-		// util constructor
-	}
-
-	/**
-	 * If Audience Mode is on this method will toggle it to be off, or
-	 * vice-versa. This results in the Frame being re-parsed and repainted.
-	 */
-	public static void ToggleAudienceMode() {
-		Frame current = DisplayIO.getCurrentFrame();
-		if (_Mode == MODE_XRAY) {
-			ToggleXRayMode();
-		}
-	
-
-		if (_Mode == MODE_AUDIENCE_FULLSCREEN) {
-			_Mode = MODE_NORMAL;
-			DisplayIO.leaveFullScreenMode();
-		}
-		else if (_Mode == MODE_AUDIENCE) {
-			if (DisplayIO.fullScreenCapable()) {
-				// Don't need to worry about UpdateConnectedToAnnotations, as this
-				// will have already been taken care of going to the 'first stage' of
-				// audience mode (MODE_AUDIENCE)
-				_Mode = MODE_AUDIENCE_FULLSCREEN;
-				DisplayIO.enterFullScreenMode();
-			}
-			else {
-				// return to normal mode
-				_Mode = MODE_NORMAL;
-			}
-		} 
-		else { // must currently be in regular mode => move to audience mode
-			_Mode = MODE_AUDIENCE;
-			ItemUtils.UpdateConnectedToAnnotations(current.getItems());
-			for (Overlay o : current.getOverlays()) {
-				ItemUtils.UpdateConnectedToAnnotations(o.Frame.getItems());
-			}
-			for (Vector v : current.getVectorsDeep()) {
-				ItemUtils.UpdateConnectedToAnnotations(v.Frame.getItems());
-			}
-		}
-		FrameUtils.Parse(current);
-		DisplayIO.UpdateTitle();
-		setMaxSize(new Dimension(_MaxSize.width, MessageBay
-				.getMessageBufferHeight()
-				+ _MaxSize.height));
-		refresh(false);
-	}
-
-	/**
-	 * If X-Ray Mode is on this method will toggle it to be off, or vice-versa.
-	 * This results in the Frame being re-parsed and repainted.
-	 */
-	public static void ToggleXRayMode() {
-		if (_Mode == MODE_AUDIENCE) {
-			ToggleAudienceMode();
-		}
-
-		if (_Mode == MODE_XRAY) {
-			setMode(MODE_NORMAL, true);
-		} else {
-			setMode(MODE_XRAY, true);
-		}
-		DisplayIO.getCurrentFrame().refreshSize();
-		DisplayIO.UpdateTitle();
-		FrameMouseActions.getInstance().refreshHighlights();
-		FrameMouseActions.updateCursor();
-		refresh(false);
-	}
-
-	public static void setMode(int mode, boolean parse) {
-		if (_Mode == mode)
-			return;
-		_Mode = mode;
-		if (parse) {
-			Frame current = DisplayIO.getCurrentFrame();
-			current.parse();
-		}
-	}
-
-	public static void forceXRayMode(boolean parse) {
-		setMode(MODE_XRAY,parse);
-	}
-	
-	/**
-	 * @return True if Audience Mode is currently on, False otherwise.
-	 */
-	public static boolean isAudienceMode() {
-		return (_Mode == MODE_AUDIENCE) || (_Mode == MODE_AUDIENCE_FULLSCREEN);
-	}
-
-	/**
-	 * @return True if X-Ray Mode is currently on, False otherwise.
-	 */
-	public static boolean isXRayMode() {
-		return _Mode == MODE_XRAY;
-	}
-
-	public static void setMaxSize(Dimension max) {
-		if (_MaxSize == null)
-			_MaxSize = max;
-
-		// Hide the message buffer if in audience mode
-		int newMaxHeight = max.height
-				- (isAudienceMode() ? 0 : MessageBay.MESSAGE_BUFFER_HEIGHT);
-		if (newMaxHeight > 0) {
-			_MaxSize.setSize(max.width, newMaxHeight);
-		}
-		Frame current = DisplayIO.getCurrentFrame();
-		if (current != null) {
-			current.setBuffer(null);
-			current.refreshSize();
-			if (DisplayIO.isTwinFramesOn()) {
-				Frame opposite = DisplayIO.getOppositeFrame();
-
-				/* When running the test suite opposite may be null! */
-				if (opposite != null) {
-					opposite.setBuffer(null);
-					opposite.refreshSize();
-				}
-			}
-		}
-
-		if (newMaxHeight > 0) {
-			MessageBay.updateSize();
-		}
-	}
-
-	public static Dimension getMaxSize() {
-		return _MaxSize;
-	}
-
-	public static Dimension getMaxFrameSize() {
-		if (DisplayIO.isTwinFramesOn()) {
-			return new Dimension((_MaxSize.width / 2), _MaxSize.height);
-		} else
-			return _MaxSize;
-	}
-
-	/**
-	 * Sets the Graphics2D object that should be used for all painting tasks.
-	 * Note: Actual painting is done by using g.create() to create temporary
-	 * instances that are then disposed of using g.dispose().
-	 * 
-	 * @param g
-	 *            The Graphics2D object to use for all painting
-	 */
-	public static void setDisplayGraphics(Graphics2D g) {
-		_DisplayGraphics = g;
-	}
-
-	/*
-	 * Displays the given Item on the screen
-	 */
-	static void PaintItem(Graphics2D g, Item i) {
-		if (i == null || g == null)
-			return;
-
-		// do not paint annotation items in audience mode
-		if (!isAudienceMode()
-				|| (isAudienceMode() && !i.isConnectedToAnnotation() && !i
-						.isAnnotation()) || i == FrameUtils.getLastEdited()) {
-
-			Graphics2D tg = (Graphics2D) g.create();
-			i.paint(tg);
-			tg.dispose();
-		}
-	}
-
-	/**
-	 * Adds all the scaled vector items for a frame into a list. It uses
-	 * recursion to get the items from nested vector frames.
-	 * 
-	 * @param items
-	 *            the list into which the vector items will be placed.
-	 * @param vector
-	 *            the frame containing vecor items.
-	 * @param seenVectors
-	 *            the vectors which should be ignored to prevent infinate loops.
-	 * @param origin
-	 *            start point for this frame or null if it is a top level frame.
-	 * @param scale
-	 *            the factor by which the item on the vector frame are to be
-	 *            scaled.
-	 */
-	// public static void AddAllVectorItems(List<Item> items, Vector vector,
-	// Collection<Frame> seenVectors) {
-	// // Check all the vector items and add the items on the vectors
-	// if (seenVectors.contains(vector))
-	// return;
-	// seenVectors.add(vector);
-	//
-	// float originX = origin == null ? 0 : origin.x;
-	// float originY = origin == null ? 0 : origin.y;
-	//
-	// for (Vector o : vector.getVectors())
-	// AddAllVectorItems(items, o.Frame, new HashSet<Frame>(seenVectors),
-	// new Point2D.Float(originX + o.Origin.x * scale, originY
-	// + o.Origin.y * scale), o.Scale * scale,
-	// o.Foreground, o.Background);
-	// // if its the original frame then were done
-	// if (origin == null) {
-	// ItemUtils.EnclosedCheck(items);
-	// return;
-	// }
-	// // Put copies of the items shifted to the origin of the VectorTag
-	// items.addAll(ItemUtils
-	// .CopyItems(vector.getNonAnnotationItems(), vector));
-	//		
-	// }
-	/**
-	 * Recursive function similar to AddAllOverlayItems.
-	 * 
-	 * @param widgets
-	 *            The collection the widgets will be added to
-	 * @param overlay
-	 *            An "overlay" frame - this intially will be the parent frame
-	 * @param seenOverlays
-	 *            Used for state in the recursion stack. Pass as an empty
-	 *            (non-null) list.
-	 */
-	public static void AddAllOverlayWidgets(List<InteractiveWidget> widgets,
-			Frame overlay, List<Frame> seenOverlays) {
-		if (seenOverlays.contains(overlay))
-			return;
-
-		seenOverlays.add(overlay);
-
-		for (Overlay o : overlay.getOverlays())
-			AddAllOverlayWidgets(widgets, o.Frame, seenOverlays);
-
-		widgets.addAll(overlay.getInteractiveWidgets());
-	}
-
-	private static Image Paint(Frame toPaint, Area clip) {
-		return Paint(toPaint, clip, true, true);
-	}
-
-	/**
-	 * 
-	 * @param toPaint
-	 * @param clip
-	 *            If null, then no clip applied.
-	 * @param isActualFrame
-	 * @return
-	 */
-	private static Image Paint(Frame toPaint, Area clip, boolean isActualFrame,
-			boolean createVolitile) {
-		if (toPaint == null)
-			return null;
+	private static Item _lastToolTippedItem = null;
+
+	/** Static-only class. */
+	private FrameGraphics()
+	{
+	}
+
+	/**
+	 * Gets an image of the given frame that has the given dimensions. If clip
+	 * is not null, only the areas inside clip are guaranteed to be drawn.
+	 */
+	public static Image getFrameImage(Frame toPaint, Clip clip, Dimension size)
+	{
+		return getFrameImage(toPaint, clip, size, true, true);
+	}
+
+	/**
+	 * Gets an image of the given frame that has the given dimensions. If clip
+	 * is not null, only the areas inside clip are guaranteed to be drawn.
+	 */
+	public static Image getFrameImage(Frame toPaint, Clip clip, Dimension size, boolean isActualFrame, boolean createVolatile)
+	{
+		if (toPaint == null) return null;
 
 		// the buffer is not valid, so it must be recreated
 		if (!toPaint.isBufferValid()) {
+			
 			Image buffer = toPaint.getBuffer();
-			if (buffer == null) {
-				GraphicsEnvironment ge = GraphicsEnvironment
-						.getLocalGraphicsEnvironment();
-				if (createVolitile) {
-					buffer = ge.getDefaultScreenDevice()
-							.getDefaultConfiguration()
-							.createCompatibleVolatileImage(_MaxSize.width,
-									_MaxSize.height);
+			// Get the size if it hasn't been given
+			if (size == null) {
+				// Can't get the size if there is no buffer
+				if (buffer == null) {
+					return null;
 				} else {
-					buffer = new BufferedImage(_MaxSize.width, _MaxSize.height,
-							BufferedImage.TYPE_INT_ARGB);
-				}
+					size = buffer.getSize();
+				}
+			}
+			
+			if (buffer == null || !buffer.getSize().equals(size)) {
+				buffer = Image.createImage(size.width, size.height, createVolatile);
 				toPaint.setBuffer(buffer);
-			}
-
-			Graphics2D bg = (Graphics2D) buffer.getGraphics();
-			paintFrame(toPaint, clip, isActualFrame, createVolitile, bg);
-
-			bg.dispose();
+				clip = null;
+			}
+			
+			EcosystemManager.getGraphicsManager().pushDrawingSurface(buffer);
+			EcosystemManager.getGraphicsManager().pushClip(clip);
+			paintFrame(toPaint, isActualFrame, createVolatile);
+			EcosystemManager.getGraphicsManager().popDrawingSurface();
 		}
 
@@ -361,24 +104,15 @@
 	}
 
-	/**
-	 * @param toPaint
-	 * @param clip
-	 * @param isActualFrame
-	 * @param createVolitile
-	 * @param bg
-	 */
-	public static void paintFrame(Frame toPaint, Area clip,
-			boolean isActualFrame, boolean createVolitile, Graphics2D bg) {
-
+	/** TODO: Comment. cts16 */
+	public static void paintFrame(Frame toPaint, boolean isActualFrame, boolean createVolitile)
+	{
+		Clip clip = EcosystemManager.getGraphicsManager().peekClip();
+		
 		// Prepare render passes
 		if (isActualFrame) {
-			currentClip = clip;
 			for (FrameRenderPass pass : _frameRenderPasses) {
-				currentClip = pass.paintStarted(currentClip);
-				clip = currentClip;
-			}
-		}
-
-		bg.setClip(clip);
+				clip = pass.paintStarted(clip);
+			}
+		}
 
 		// TODO: Revise images and clip - VERY IMPORTANT
@@ -386,10 +120,9 @@
 		// Nicer looking lines, but may be too jerky while
 		// rubber-banding on older machines
-		if (UserSettings.AntiAlias.get())
-			bg.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
-					RenderingHints.VALUE_ANTIALIAS_ON);
-		// If we are doing @f etc... then have a clear background if its the
-		// default background color
-		Color backgroundColor = null;
+		if (UserSettings.AntiAlias.get()) EcosystemManager.getGraphicsManager().setAntialiasing(true);
+		
+		// If we are doing @f etc... then have a clear background if its the default background color
+		Colour backgroundColor = null;
+		
 		// Need to allow transparency for frameImages
 		if (createVolitile) {
@@ -397,19 +130,11 @@
 		} else {
 			backgroundColor = toPaint.getBackgroundColor();
-			if (backgroundColor == null)
-				backgroundColor = Item.TRANSPARENT;
-		}
-
-		// if(isActual)
-		bg.setColor(backgroundColor);
-		if (isActualFrame) {
-			// bg.setColor(Color.white); // TODO: TEMP FOR DEBUGGING
-
-			// System.out.println("paintPic");
-		}
-		bg.fillRect(0, 0, _MaxSize.width, _MaxSize.height);
+			if (backgroundColor == null) backgroundColor = Item.TRANSPARENT;
+		}
+
+		EcosystemManager.getGraphicsManager().clear(backgroundColor);
 
 		List<Item> visibleItems = new LinkedList<Item>();
-		List<InteractiveWidget> paintWidgets;
+		List<Widget> paintWidgets;
 
 		if (isActualFrame) {
@@ -417,6 +142,6 @@
 			// frames
 			visibleItems.addAll(toPaint.getAllItems());
-			paintWidgets = new LinkedList<InteractiveWidget>();
-			AddAllOverlayWidgets(paintWidgets, toPaint, new LinkedList<Frame>());
+			paintWidgets = toPaint.getAllOverlayWidgets();
+			paintWidgets.addAll(toPaint.getInteractiveWidgets());
 		} else {
 			visibleItems.addAll(toPaint.getVisibleItems());
@@ -425,16 +150,14 @@
 		}
 
-
-				HashSet<Item> paintedFillsAndLines = new HashSet<Item>();
+		HashSet<Item> paintedFillsAndLines = new HashSet<Item>();
 		// FIRST: Paint widgets swing gui (not expeditee gui) .
 		// Note that these are the anchored widgets
-		ListIterator<InteractiveWidget> widgetItor = paintWidgets
-				.listIterator(paintWidgets.size());
+		ListIterator<Widget> widgetItor = paintWidgets.listIterator(paintWidgets.size());
 		while (widgetItor.hasPrevious()) {
 			// Paint first-in-last-serve ordering - like swing
 			// If it is done the other way around then widgets are covered up by
 			// the box that is supposed to be underneath
-			InteractiveWidget iw = widgetItor.previous();
-			if (clip == null || clip.intersects(iw.getComponant().getBounds())) {
+			Widget iw = widgetItor.previous();
+			if (clip == null || clip.getBounds() == null || clip.getBounds().intersects(iw.getBounds())) {
 				paintedFillsAndLines.addAll(iw.getItems());
 				//iw.paint(bg);
@@ -457,5 +180,5 @@
 			paintItems = new LinkedList<Item>();
 			for (Item i : visibleItems) {
-				if (i.isInDrawingArea(clip)) {
+				if (clip == null || i.isInDrawingArea(clip.getBounds())) {
 					paintItems.add(i);
 				} else if (i.isEnclosed()) {
@@ -469,8 +192,8 @@
 			}
 		}
-		// Only paint files and lines once ... between anchored AND free
-		// items
-		PaintPictures(bg, paintItems, fillOnlyItems, paintedFillsAndLines);
-		PaintLines(bg, visibleItems);
+		
+		// Only paint files and lines once ... between anchored AND free items
+		PaintPictures(paintItems, fillOnlyItems, paintedFillsAndLines);
+		PaintLines(visibleItems);
 
 
@@ -480,8 +203,8 @@
 			// If it is done the other way around then widgets are covered up by
 			// the box that is supposed to be underneath
-			InteractiveWidget iw = widgetItor.previous();
-			if (clip == null || clip.intersects(iw.getComponant().getBounds())) {
-				iw.paint(bg);
-				PaintItem(bg, iw.getItems().get(4));
+			Widget iw = widgetItor.previous();
+			if (clip == null || clip.isNotClipped() || clip.getBounds().intersects(iw.getBounds())) {
+				iw.paint();
+				PaintItem(iw.getItems().get(4));
 			}
 		}
@@ -494,5 +217,5 @@
 		// Dont paint the free items for the other frame in twin frames mode
 		// if (toPaint == DisplayIO.getCurrentFrame()) {
-		if (clip == null) {
+		if (clip == null || clip.isNotClipped()) {
 			freeItemsToPaint = FreeItems.getInstance();
 		} else {
@@ -500,5 +223,5 @@
 			fillOnlyItems.clear();
 			for (Item i : FreeItems.getInstance()) {
-				if (i.isInDrawingArea(clip)) {
+				if (i.isInDrawingArea(clip.getBounds())) {
 					freeItemsToPaint.add(i);
 				} else if (i.isEnclosed()) {
@@ -509,18 +232,19 @@
 		// }
 
-		if (isActualFrame && toPaint == DisplayIO.getCurrentFrame())
-			PaintPictures(bg, freeItemsToPaint, fillOnlyItems,
-					paintedFillsAndLines);
+		if (isActualFrame && toPaint == DisplayController.getCurrentFrame()) {
+			PaintPictures(freeItemsToPaint, fillOnlyItems, paintedFillsAndLines);
+		}
+		
 		// TODO if we can get transparency with FreeItems.getInstance()...
 		// then text can be done before freeItems
-		PaintNonLinesNonPicture(bg, paintItems);
+		PaintNonLinesNonPicture(paintItems);
 
 		// toPaint.setBufferValid(true);
 
-		if (isActualFrame && !isAudienceMode()) {
-			PaintItem(bg, toPaint.getNameItem());
-		}
-
-		if (DisplayIO.isTwinFramesOn()) {
+		if (isActualFrame && !DisplayController.isAudienceMode()) {
+			PaintItem(toPaint.getNameItem());
+		}
+
+		if (DisplayController.isTwinFramesOn()) {
 			List<Item> lines = new LinkedList<Item>();
 			for (Item i : freeItemsToPaint) {
@@ -528,5 +252,5 @@
 					Line line = (Line) i;
 
-					if (toPaint == DisplayIO.getCurrentFrame()) {
+					if (toPaint == DisplayController.getCurrentFrame()) {
 						// If exactly one end of the line is floating...
 
@@ -560,188 +284,47 @@
 				}
 			}
-			if (isActualFrame)
-				PaintLines(bg, lines);
+			
+			if (isActualFrame) PaintLines(lines);
 		} else {
-			// Don't paint the
-			if (isActualFrame)
-				PaintLines(bg, freeItemsToPaint);
-		}
-
-		if (isActualFrame && toPaint == DisplayIO.getCurrentFrame())
-			PaintNonLinesNonPicture(bg, freeItemsToPaint);
+			if (isActualFrame) PaintLines(freeItemsToPaint);
+		}
+
+		if (isActualFrame && toPaint == DisplayController.getCurrentFrame()) {
+			PaintNonLinesNonPicture(freeItemsToPaint);
+		}
 
 		// Repaint popups / drags... As well as final passes
 		if (isActualFrame) {
 			for (FrameRenderPass pass : _frameRenderPasses) {
-				pass.paintPreLayeredPanePass(bg);
-			}
-			PopupManager.getInstance().paintLayeredPane(bg, clip);
+				pass.paintPreLayeredPanePass();
+			}
+			
+			//if (PopupManager.getInstance() != null) PopupManager.getInstance().paintLayeredPane(clip == null ? null : clip.getBounds());
+			
 			for (FrameRenderPass pass : _frameRenderPasses) {
-				pass.paintFinalPass(bg);
+				pass.paintFinalPass();
 			}
 		}
 		
 		// paint tooltip
-		if(!FreeItems.itemsAttachedToCursor()) {
+		if(!FreeItems.hasItemsAttachedToCursor()) {
 			Item current = FrameUtils.getCurrentItem();
-			if(current != null) {
-				current.paintTooltip(bg);
-			} //else {
-//				Item.clearTooltipOwner();
-//			}
-			if(previous != null) previous.clearTooltips();
-			previous = current;
-		}
-
-		if (FreeItems.hasCursor()
-				&& DisplayIO.getCursor() == Item.DEFAULT_CURSOR)
-			PaintNonLinesNonPicture(bg, FreeItems.getCursor());
-	}
-	
-	private static Item previous = null;
-
-	// creates a new line so that lines are shown correctly when spanning
-	// across frames in TwinFrames mode
-	// private static Line TransposeLine(Line line, Item d, Frame toPaint,
-	// int base, int adj) {
-	// Line nl = null;
-	//
-	// if (toPaint != DisplayIO.getCurrentFrame() && d.getParent() == null
-	// && line.getOppositeEnd(d).getParent() == toPaint) {
-	// nl = line.copy();
-	// if (d == line.getStartItem())
-	// d = nl.getStartItem();
-	// else
-	// d = nl.getEndItem();
-	//
-	// if (DisplayIO.FrameOnSide(toPaint) == 0)
-	// d.setX(base);
-	// else
-	// d.setX(base + adj);
-	//
-	// } else if (toPaint == DisplayIO.getCurrentFrame()
-	// && d.getParent() == null
-	// && line.getOppositeEnd(d).getParent() != toPaint) {
-	// nl = line.copy();
-	//
-	// if (d == line.getStartItem())
-	// d = nl.getEndItem();
-	// else
-	// d = nl.getStartItem();
-	//
-	// if (DisplayIO.FrameOnSide(toPaint) == 1)
-	// d.setX(d.getX() - DisplayIO.getMiddle());
-	// else
-	// d.setX(d.getX() + DisplayIO.getMiddle());
-	// }
-	// if (nl != null) {
-	// nl.invalidateAll();
-	// FrameGraphics.requestRefresh(true);
-	// }
-	// return nl;
-	// }
-
-	private static void Paint(Graphics g, Image left, Image right,
-			Color background) {
-
-	    // Triggers a FrameTransition is this has been signalled
-	    // through an '@frameTransition: xxxx' on the frame.  The type of
-	    // transition is specified in the 'xxxx' part
-
-
-		// if TwinFrames mode is on, then clipping etc has to be set
-		if (DisplayIO.isTwinFramesOn()) {
-			// draw the two lines down the middle of the window
-			if (left != null)
-				left.getGraphics().drawLine(DisplayIO.getMiddle() - 2, 0,
-						DisplayIO.getMiddle() - 2, _MaxSize.height);
-
-			if (right != null)
-				right.getGraphics().drawLine(0, 0, 0, _MaxSize.height);
-
-			// set the clipping area
-			((Graphics2D) g).setClip(0, 0, DisplayIO.getMiddle() - 1,
-					_MaxSize.height);
-			g.drawImage(left, 0, 0, Item.DEFAULT_BACKGROUND, null);
-			((Graphics2D) g).setClip(null);
-			g.drawImage(right, DisplayIO.getMiddle() + 1, 0,
-					Item.DEFAULT_BACKGROUND, null);
-
-			
-		}
-		// otherwise, just draw whichever side is active
-		else {
-		    if (DisplayIO.getCurrentSide() == 0) {
-		    	if (!paintTransition(g,left)) {
-		    		// Nothing fancy occurred, just need to render the next slide to screen
-		    		g.drawImage(left, 0, 0, Item.DEFAULT_BACKGROUND, null);
-		    	}
-		    }
-		    else {
-		    	if (!paintTransition(g,right)) {
-		    		// Nothing fancy occurred, just need to render the next slide to screen
-		    		g.drawImage(right, 0, 0, Item.DEFAULT_BACKGROUND, null);
-		    	}
-		    }
-		}
-
-	}
-
-        
-    private static boolean paintTransition(Graphics g, Image image)
-    {
-    	boolean performed_transition = false;
-    	
-    	//If we are doing a transition
-    	if(FrameTransitions.getSlide() == true){						
-
-    		String input = "org.expeditee.gui.FrameTransitions";
-    		String slide_mode_method = FrameTransitions.getslideModeMethod();
-
-    		try {
-    			Class<?> c = Class.forName(input);
-
-    			Class[] cArg = new Class[3];
-    			cArg[0] = Graphics.class;
-    			cArg[1] = Image.class;
-    			cArg[2] = Dimension.class;				       		        
-
-    			//Gets the method of transition and calls it
-    			Method lMethod = c.getDeclaredMethod(slide_mode_method, cArg);
-
-    			if(lMethod != null){
-    				// calling static method, so no class parameter needed
-    				Object o = lMethod.invoke(null, g, image, _MaxSize);
-    				performed_transition = true;
-    				
-    			}
-    			else{
-    				System.err.println("Unable to locate the transition '" + slide_mode_method + "'");
-    			}						
-
-    		} catch (Exception e) {						
-
-    			System.err.println("An Reflection Exception occurred trying to invoke '" + slide_mode_method + "'");
-    			e.printStackTrace();
-    		}	
-    	}		
-    	//Tells the frame to only transition once
-    	FrameTransitions.setSlideFalse();		
-    	
-    	return performed_transition;
-    }
-    
-
-	public static void Clear() {
-		Graphics g = _DisplayGraphics.create();
-		g.setColor(Color.WHITE);
-		g.fillRect(0, 0, _MaxSize.width, _MaxSize.height);
-		g.dispose();
-	}
-
-	private static void PaintNonLinesNonPicture(Graphics2D g, List<Item> toPaint) {
-		for (Item i : toPaint)
-			if (!(i instanceof Line) && !(i instanceof XRayable))
-				PaintItem(g, i);
+			if(current != null) current.paintTooltip();
+			if (_lastToolTippedItem != null) _lastToolTippedItem.clearTooltips();
+			_lastToolTippedItem = current;
+		}
+
+		if (FreeItems.hasCursor() && DisplayController.getCursor() == Item.DEFAULT_CURSOR) {
+			PaintNonLinesNonPicture(FreeItems.getCursor());
+		}
+	}
+
+	private static void PaintNonLinesNonPicture(List<Item> toPaint)
+	{
+		for (Item i : toPaint) {
+			if (!(i instanceof Line) && !(i instanceof XRayable)) {
+				PaintItem(i);
+			}
+		}
 	}
 
@@ -752,19 +335,20 @@
 	 * @param toPaint
 	 */
-	private static void PaintLines(Graphics2D g, List<Item> toPaint) {
+	private static void PaintLines(List<Item> toPaint)
+	{
 		// Use this set to keep track of the items that have been painted
 		Collection<Item> done = new HashSet<Item>();
-		for (Item i : toPaint)
+		for (Item i : toPaint) {
 			if (i instanceof Line) {
 				Line l = (Line) i;
 				if (done.contains(l)) {
-					l.paintArrows(g);
+					l.paintArrows();
 				} else {
 					// When painting a line all connected lines are painted too
 					done.addAll(l.getAllConnected());
-					if (l.getStartItem().getEnclosedArea() == 0)
-						PaintItem(g, i);
-				}
-			}
+					if (l.getStartItem().getEnclosedArea() == 0) PaintItem(i);
+				}
+			}
+		}
 	}
 
@@ -776,6 +360,6 @@
 	 * @param toPaint
 	 */
-	private static void PaintPictures(Graphics2D g, List<Item> toPaint,
-			HashSet<Item> fillOnlyItems, HashSet<Item> done) {
+	private static void PaintPictures(List<Item> toPaint, HashSet<Item> fillOnlyItems, HashSet<Item> done)
+	{
 
 		List<Item> toFill = new LinkedList<Item>();
@@ -783,8 +367,7 @@
 			// Ignore items that have already been done!
 			// Also ignore invisible items..
-			// TODO possibly ignore invisible items before coming to this
-			// method?
-			if (done.contains(i))
-				continue;
+			// TODO possibly ignore invisible items before coming to this method?
+			if (done.contains(i)) continue;
+			
 			if (i instanceof XRayable) {
 				toFill.add(i);
@@ -792,10 +375,8 @@
 			} else if (i.hasEnclosures()) {
 				for (Item enclosure : i.getEnclosures()) {
-					if (!toFill.contains(enclosure))
-						toFill.add(enclosure);
+					if (!toFill.contains(enclosure)) toFill.add(enclosure);
 				}
 				done.addAll(i.getConnected());
-			} else if (i.isLineEnd()
-					&& (!isAudienceMode() || !i.isConnectedToAnnotation())) {
+			} else if (i.isLineEnd() && (!DisplayController.isAudienceMode() || !i.isConnectedToAnnotation())) {
 				toFill.add(i);
 				done.addAll(i.getAllConnected());
@@ -805,7 +386,7 @@
 		if (fillOnlyItems != null) {
 			for (Item i : fillOnlyItems) {
-				if (done.contains(i))
+				if (done.contains(i)) {
 					continue;
-				else if (!isAudienceMode() || !i.isConnectedToAnnotation()) {
+				} else if (!DisplayController.isAudienceMode() || !i.isConnectedToAnnotation()) {
 					toFill.add(i);
 				}
@@ -821,27 +402,35 @@
 				int cmp = aArea.compareTo(bArea);
 				if (cmp == 0) {
-					// System.out.println(a.getEnclosureID() + " " +
-					// b.getID());\
 					// Shapes to the left go underneath
-					Polygon pA = a.getEnclosedShape();
-					Polygon pB = b.getEnclosedShape();
-					if (pA == null || pB == null)
-						return 0;
-					return new Integer(pA.getBounds().x).compareTo(pB
-							.getBounds().x);
+					PolygonBounds pA = a.getEnclosedShape();
+					PolygonBounds pB = b.getEnclosedShape();
+					if (pA == null || pB == null) return 0;
+					return new Integer(pA.getMinX()).compareTo(pB.getMinX());
 				}
 				return cmp * -1;
 			}
 		});
+		
 		for (Item i : toFill) {
 			if (i instanceof XRayable) {
-				PaintItem(g, i);
+				PaintItem(i);
 			} else {
 				// Paint the fill and lines
-				i.paintFill(g);
+				i.paintFill();
 				List<Line> lines = i.getLines();
-				if (lines.size() > 0)
-					PaintItem(g, lines.get(0));
-			}
+				if (lines.size() > 0) PaintItem(lines.get(0));
+			}
+		}
+	}
+
+	/** Displays the given Item on the screen. */
+	static void PaintItem(Item i)
+	{
+		if (i == null) return;
+
+		// do not paint annotation items in audience mode
+		if (!DisplayController.isAudienceMode() || (!i.isConnectedToAnnotation() && !i.isAnnotation()) || i == FrameUtils.getLastEdited())
+		{
+			i.paint();
 		}
 	}
@@ -862,34 +451,39 @@
 			// Check if within 20% of the end of the line
 			Line l = (Line) i;
-			Item toDisconnect = l.getEndPointToDisconnect(Math
-					.round(FrameMouseActions.MouseX), Math
-					.round(FrameMouseActions.MouseY));
+			Item toDisconnect = l.getEndPointToDisconnect(DisplayController.getMousePosition());
 
 			// Brook: Widget Edges do not have such a context
 			if (toDisconnect != null && !(i instanceof WidgetEdge)) {
 				Item.HighlightMode newMode = toDisconnect.getHighlightMode();
-				if (FreeItems.itemsAttachedToCursor())
+				if (FreeItems.hasItemsAttachedToCursor())
 					newMode = Item.HighlightMode.Normal;
 				// unhighlight all the other dots
 				for (Item conn : toDisconnect.getAllConnected()) {
 					conn.setHighlightMode(Item.HighlightMode.None);
+					conn.setHighlightColorToDefault();
 				}
 				l.setHighlightMode(newMode);
+				l.setHighlightColorToDefault();
 				// highlight the dot that will be in disconnect mode
 				toDisconnect.setHighlightMode(newMode);
+				toDisconnect.setHighlightColorToDefault();
 				i = toDisconnect;
 			} else {
-				if(FrameMouseActions.isShiftDown()) {
+				if (StandardInputEventListeners.kbmStateListener.isKeyDown(Key.SHIFT)) {
 					for(Item j : i.getAllConnected()) {
         				if(j instanceof Dot && !j.equals(i)) {
         					j.setHighlightMode(HighlightMode.None);
+        					j.setHighlightColorToDefault();
         				}
         			}
         			l.getStartItem().setHighlightMode(HighlightMode.Connected);
+        			l.getStartItem().setHighlightColorToDefault();
         			l.getEndItem().setHighlightMode(HighlightMode.Connected);
+        			l.getEndItem().setHighlightColorToDefault();
         		} else {
         			for(Item j : i.getAllConnected()) {
         				if(j instanceof Dot && !j.equals(i)) {
         					j.setHighlightMode(HighlightMode.Connected);
+        					j.setHighlightColorToDefault();
         				}
         			}
@@ -902,4 +496,5 @@
 		} else if (i instanceof Circle) {
 			i.setHighlightMode(Item.HighlightMode.Connected);
+			i.setHighlightColorToDefault();
 		} else if (!i.isVisible()) {
 			changeHighlightMode(i, Item.HighlightMode.Connected, null);
@@ -913,8 +508,9 @@
 			// highlight connected dots, but only if there aren't items being carried on the cursor
 			if(FreeItems.getInstance().size() == 0) {
-    			if(FrameMouseActions.isShiftDown()) {
+    			if (StandardInputEventListeners.kbmStateListener.isKeyDown(Key.SHIFT)) {
         			for(Item j : i.getAllConnected()) {
         				if(j instanceof Dot && !j.equals(i)) {
         					j.setHighlightMode(HighlightMode.Connected);
+        					j.setHighlightColorToDefault();
         				}
         			}
@@ -923,4 +519,5 @@
         				if(j instanceof Dot && !j.equals(i)) {
         					j.setHighlightMode(HighlightMode.None);
+        					j.setHighlightColorToDefault();
         				}
         			}
@@ -928,4 +525,5 @@
         				Item j = l.getOppositeEnd(i);
        					j.setHighlightMode(HighlightMode.Connected);
+       					j.setHighlightColorToDefault();
         			}
         		}
